#! /usr/bin/perl -w

use strict;
use File::Path;
use File::Basename;
use Getopt::Long;

my $FILE_EULA = 'EULA.txt';
my $DOWNLOAD_SERVER = "http://dls.photoprintit.de/";
## JGE
my $KEYACCID = '5500';
my $CLIENTID = '38';
my $HPS_VER = '4.5.9';
my $VENDOR_NAME = 'dm';
my $APPLICATION_NAME = 'dm paradies foto 2';
my $HAS_PHOTOFUN = 'true';
my $HAS_CANVAS = 'true';
my $HAS_POSTER = 'true';
my $HAS_PREMIUMFOTO = 'true';
my $HAS_BUDGETFOTO = 'true';
my $HAS_CALENDARS = 'true';
my $HAS_FOTOBOOKS = 'true';
my $HAS_THEME_DESIGN = 'true';
my $HAS_THEME_DMBABY = 'false';
my $HAS_THEME_ALB = 'true';
my $PROGRAM_NAME_FOTOSHOW = 'Prezentace fotografií';
 
## /JGE
my $DESKTOP_ICON_NAME = 'dm paradies foto 2.desktop';
my $DESKTOP_ICON_PATH = '/Resources/keyaccount/32.xpm';
my $SERVICES_XML_PATH = '/Resources/services.xml';
my $AFFILIATE_ID = '';

my $ANSWER_YES = 'ano';
my $ANSWER_NO = 'ne';
my $WELCOME = "Tento Script Vám pomůže při instalaci '$APPLICATION_NAME' na Vašem po?íta?ia provede Vás krok za krokem instala?ním procesem.\n\n\n";
my $EULA_READ = "Prosím, pře?těte si pozorně VOP. V závěru musíte s VOP souhlasit.\tV rámci VOP se můžete pohybovat za pomoci kláves šipek. Stisknutím klávesy 'q' vyskošíte z VOP.\n\tDále s použitím[CR].";
my $EULA_ACCEPT = "\tSouhlasíte s VOP? [$ANSWER_YES/".uc($ANSWER_NO)."] ";
my $EULA_NOTACCEPTED = "\tNesouhlasili jste s VOP.\n'$APPLICATION_NAME' nemůže být bohužel na Vašem po?íta?i instalován.\n\n\n";
my $INSTALL_DIR_QUESTION_FORMAT = "Kam má být'$APPLICATION_NAME' instalován? [%s] ";
my $DOWNLOAD_MSG = "\tChcete pokra?ovat v instalaci a potřebná data stáhnout z internetu? [".uc($ANSWER_YES)."/".$ANSWER_NO."] ";
my $DOWNLOAD_MSG_FORMAT = "\tStahování: '%s'\n";
my $UNPACK_MSG = "Potřebné soubory se právě rozbalují v instala?ním adresáři.\n";
my $FINISHED_MSG_FORMAT = "\nGratulujeme!\nÚspěšne jste na svém po?íta?i instalovali'$APPLICATION_NAME'.\nPro spuštní rozbalte prosím soubour'%s/$APPLICATION_NAME'.\n\nPěknou zábavu!\n";
my $DOWNLOAD_RETRY = "Chcete se opětovně pokusit stáhnout soubor? [$ANSWER_YES/".uc($ANSWER_NO)."] ";
my $PACKAGE_SIZE_FORMAT = "\t\t%s %s\t%s (%s)\n";
my $TOTAL_DOWNLOAD_SIZE_FORMAT = "\tJeště celkem %.1fMb dat musí být staženo z internetu.\n";
my $PRE_PACKAGELIST_MSG = "Pro úspěšnou instalaci je potřeba stáhnout z internetu ještě následující složky.\n";
my @ANSWER_YES_LIST = ("a", "ano", "a", "ano");
my @ANSWER_NO_LIST = ("n", "ne", "ne");

######################################################################################################################
# Od tohoto místa by se nemělo nic měnit
######################################################################################################################
my $INSTALL_DIR_DEV = "$VENDOR_NAME/$APPLICATION_NAME";
my $INDEX_FILE_PATH_ON_SERVER = "/download/Data/$KEYACCID/hps/$CLIENTID-index-$HPS_VER.txt";
my $LOG_FILE_DIR = '.log';
my @REQUIRED_PROGRAMMS = ("unzip", "md5sum", "less", "wget");
my $DESKTOP_ICON_FORMAT = "[Desktop Entry]\n".
			  "Comment=\n".
			  "Comment[de]=\n".
			  "Encoding=UTF-8\n".
			  "Exec=\"%s/$APPLICATION_NAME\"\n".
			  "Icon=%s$DESKTOP_ICON_PATH\n".
			  "Name=$APPLICATION_NAME\n".
			  "Name[de]=$APPLICATION_NAME\n".
			  "StartupNotify=true\n".
			  "Terminal=false\n".
			  "TerminalOptions=\n".
			  "Type=Application\n";
my $SERVICES_XML_FORMAT = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>
<services>
<service name=\"a\">t856EvnDTL56xD5fHQnWrzqVk6Xj3we4xGYHfShPmkqXtCzbI21eqJ57eIHVViAg</service>
<service name=\"b\">SNCxjcl5y86nasXrdmtwTWWbBmFs3j21rZOVvoZT9HleOfGJR7FGgZiXsS623ctV</service>
<service name=\"c\">7iIwPfB9c6TIRuf9SPd7I1j25Pex9atTL9TDepMD6nkAyDliZhvIlJOC2tm9pcyQ</service>
<service name=\"d\">%s</service>
<service name=\"e\">EQBuKJf7pzVIbNXzz19PlwkVpERC5KfsWJbG4cazpn3PFC5Rtz4O3V87KcWfMgxK</service>
<service name=\"f\">8ksOkroMJFn1Es3zVJyzxJggNaXiMuLKBfPLBtCyek1bZBcTy29gaU7nm75ZYIxz</service>
<service name=\"g\">xHuXMWCLmtrwNIBvqVB9BAyPjNpEa9gNuybXU51bKsryDqc2UJxSQXM8yIhbIarq</service>
<service name=\"h\">sKTtqevc5EdBSwi3bZkngwl4NSolB8vFc7kPWeAEB4Y1ySgUIgcjJGxKlOll8c8e</service>
</services>\n";



######################################################################################################################
# Proměnné
######################################################################################################################
my $indexContent;			# Obsahuje obsah indexového souboru.
my @filesToDownload;			# Obsahuje názvy souborů, které se musí stáhnout.
my @downloadedFiles;			# Obsahuje názvy souborů, které byly staženy.
my @filesToRemove;			# Obsahuje názvy souborů, které se na koci Scriptu musí smazat.
my $fileName;				# Obsahuje jméno souboru, který je třeba aktuálně zpracovat.
my $update;
my $installDir="";
my $sourceDir="";
my $changeInstallDir=1;
my $verbose;
my $keepPackages=0;



######################################################################################################################
# Ukázat krátký pomocný text
######################################################################################################################
sub showHelp {
	print $WELCOME;
	print "Možnosti řádků pokynů:\n";
	print "   -h; --help\n";
	print "   -i; --installdir=<DIR>\tAdresář má být instalován do'$APPLICATION_NAME'\n";
	print "   -k; --keepPackages\t\tStažené soubory nebudou smazány a lze je použít pro další instalaci.\n";
	print "   -s; --source=<DIR>\t\tAdresář v němž jsou obsaženy instala?ní složky.\n";
#	print "   --update\t\tStávající instalace je updateována.Je třeba -- installdir.\n";
	print "   -v; --verbose\t\tVydává informace při stahování.\n";
	print "\n";
	print "Script hledá instal?ní složky v aktuálním nebo zdrojem zadaném adresáři... Pokud je tam nenajde, pak je stáhne z internetu.\n";
	print "\n";
}



######################################################################################################################
# Parse parametry řádků pokynů
######################################################################################################################
sub getOptions {
	$update=0;
	$verbose=0;
	$installDir="";
	my $help=0;
	
	GetOptions("installdir=s" => \$installDir,
			"update" => \$update,
			"verbose" => \$verbose,
			"help" => \$help,
			"keepPackages" => \$keepPackages,
			"source=s" => \$sourceDir) || die "Chybí údaje.";
	
	if($help == 1) {
		showHelp;
		exit 0;
	}
	
	
	if($update == 1) {
		if($installDir eq "") {
			print "Není zadán žádný instala?ní adresář.\n";
			exit 1;
		}
	}
	
	if($installDir ne "") {
		$changeInstallDir=0;
	}
}



######################################################################################################################
# Přezkoušet, zda jsou k dispozici potřebné programy
######################################################################################################################
sub checkProgramms {
	foreach (@REQUIRED_PROGRAMMS) {
		my $status=system("which $_ > /dev/null 2>&1");
		
		if(0!=$status) {
			print "Ke správnému provedení scriptu je třeba program '$_'.\n";
			exit 1;
		}
	}
}



######################################################################################################################
# Ukázat VOP
######################################################################################################################
sub showEula {
	if($FILE_EULA ne "" && $update==0) {
		if(!open(EULA, "<", $FILE_EULA)) {
			print "Soubor ".$FILE_EULA." nelze najít.\n";
			exit 1;
		}
		close EULA;
		print $EULA_READ;
		my $answer = <STDIN>;
		
		system("less $FILE_EULA");
		
		print $EULA_ACCEPT;
		chomp($answer = <STDIN>);
		$answer=lc($answer);
		
		my $found=0;
		foreach(@ANSWER_YES_LIST) {
			if($answer eq $_) {
				$found=1;
				last;
			}
		}
		
		if(0==$found) {
			print $EULA_NOTACCEPTED;
			exit;
		}
	}
}



######################################################################################################################
# Zeptat se na instala?ní adresář
######################################################################################################################
sub getInstallDir {
	if($update == 0 && $changeInstallDir == 1) {
		if($> == 0) {
			# Root User
			$installDir="/opt/".$INSTALL_DIR_DEV;
		}
		else {
			# Normaler Benutzer
			$installDir=$ENV{"HOME"}."/".$INSTALL_DIR_DEV;
		}
		
		printf $INSTALL_DIR_QUESTION_FORMAT, $installDir;
		my $answer = <STDIN>;
		chomp($answer);
		
		if("" ne $answer) {
			$installDir=$answer;
		}
	}
}



######################################################################################################################
#Opatřit indexový soubor 
######################################################################################################################
sub getIndexFile {
	my $downloaded	= 0;
	my $answer	= 1;
	
	$fileName	= basename($INDEX_FILE_PATH_ON_SERVER);
	
	if( -e $sourceDir."/".$fileName) {
		$fileName=$sourceDir."/".$fileName;
	} elsif(! -e $fileName) {
		# Opatřit indexový soubor ze sítě.
		if(0==$verbose) {
			$answer = system("wget -q $DOWNLOAD_SERVER$INDEX_FILE_PATH_ON_SERVER");
		}
		else {
			$answer = system("wget $DOWNLOAD_SERVER$INDEX_FILE_PATH_ON_SERVER");
		}
		
		if($answer!=0) {
			print "Stáhnutí souboru: ", $DOWNLOAD_SERVER.$INDEX_FILE_PATH_ON_SERVER, " se nezdařilo\n";
			exit 1;
		}
		
		$downloaded=1;
	}
	
	if(!open(INDEX, "<", $fileName)) {
		print "Indexový soubor se nepodařilo otevřít";
		exit 1;
	}
	else {
		while(<INDEX>) {
			$indexContent.=$_;
		}
		
		close(INDEX);
		
		if(1==$downloaded && $keepPackages==0) {
			unlink($fileName);
		}
	}
}



######################################################################################################################
# Přezkoušet indexový soubor a vyhledat soubory ur?ené ke stažení
######################################################################################################################
sub checkIndexFile {
	my $totalSize		= 0;
	my $packageString	= "";
	
	foreach (split(/[\r\n]+/, $indexContent)) {
		chomp;
		if(/^(.*);(.*);(.*);(.*)$/) {
			my $filePath	= $1;
			my $required	= $2;
			my $what	= $3;
			my $system	= $4;
			
			if($system eq "l" || $system eq "a") {
				$fileName	= basename($filePath);
				
				if(! -e $installDir."/".$LOG_FILE_DIR."/".$fileName.".log") {
					# Soubor ještě není nainstalován.
					if( -e $sourceDir."/".$fileName) {
						# Soubor je k dispozici lokálně,není tedy třeba jej stahovat. 
						push(@downloadedFiles, $sourceDir."/".$fileName);
					} elsif( -e $fileName ) {
						# Soubor je k dispozici lokálně, není tedy třeba jej stahovat.
						push(@downloadedFiles, $fileName);
					}
					else {
						# Data musí být stažena ze sítě.Vypišme tedy kolik musí být staženo.
						my $spider			= `export LANG=C;wget --spider $DOWNLOAD_SERVER/$filePath 2>&1`;
						my ($size, $dummy, $mb, $mime)	= $spider=~/Length:\s+([\d,]+)\s+(\(([\d\.]+[MK]?)\))?\s*(\[.*\])/;
						my $string			= sprintf $PACKAGE_SIZE_FORMAT, $what, $mime, $size, $mb;
						$packageString			.= $string;
						push(@filesToDownload, $_);
						$size=~s/,//g;
						$totalSize+=$size;
					}
				}
			}
		}
	}
	
	if(0!=(scalar @filesToDownload)) {
		print $PRE_PACKAGELIST_MSG;
		print $packageString;
		printf $TOTAL_DOWNLOAD_SIZE_FORMAT, $totalSize/(1024*1024);
	}
}



######################################################################################################################
# Roleback
######################################################################################################################
sub roleback {
	my ($fileName) = @_;
	$fileName =~ /^(.*)_.*$/;
	my $packageName=$1;
	
	if(opendir(LOG_FILE_DIR, $installDir."/".$LOG_FILE_DIR)) {
		my @allFiles=readdir(LOG_FILE_DIR);
		@allFiles=grep(!/^\./, @allFiles);
		
		close(LOG_FILE_DIR);
		
		foreach(@allFiles) {
			$_ =~ /^(.*)_.*$/;
			
			if($1 eq $packageName) {
				removePackage($_);
			}
		}
	}
}



######################################################################################################################
# Mazat soubory z Logfile a Logfile samo
######################################################################################################################
sub removePackage {
	my ($logFile) = @_;
	my @files;
	my @dirs;
	
	if(open(LOG_FILE, "<", $installDir."/".$LOG_FILE_DIR."/".$logFile)) {
		while(<LOG_FILE>) {
			if(/^\s*inflating:\s+(.*)/) {
				my $file=$1;
				$file =~ s/^\s+|\s+$//;
				push(@files, $file);
			}
			if(/^\s*creating:\s+(.*)\s*$/) {
				push(@dirs, $1);
			}
		}
		close LOG_FILE;
	}
	
	# Připojit Logfile na seznam souborů, ur?ených ke smazání.
	push (@files, $installDir."/".$LOG_FILE_DIR."/".$logFile);
	
	unlink(@files);
	
	@dirs = reverse @dirs;
	foreach(@dirs) {
		rmdir $_;
	}
}



######################################################################################################################
# Stáhnou všechny soubory z indexového souboru
######################################################################################################################
sub downloadFiles {
	if(0!=(scalar @filesToDownload)) {
		if($update == 0) {
			my $answer;
			
			print $DOWNLOAD_MSG;
		
			chomp($answer = <STDIN>);
			$answer=lc($answer);
			
			foreach(@ANSWER_NO_LIST) {
				if($answer eq $_) {
					exit 1;
					last;
				}
			}
		}
		
		# Stahování souboru
		foreach (@filesToDownload) {
			chomp;
			$_ =~ /^(.*);.*;(.*);.*$/;
			my $filePath	= $1;
			my $what	= $2;
			my $error	= 0;
			my $retry	= 1;
			
			$fileName	= basename($filePath);
			
			printf $DOWNLOAD_MSG_FORMAT, $what;
			
			while(1==$retry) {
				my $result=1;
				
				if(0==$verbose) {
					$result=system("wget -q $DOWNLOAD_SERVER/$filePath -O $fileName");
				}
				else {
					$result=system("wget $DOWNLOAD_SERVER/$filePath -O $fileName");
				}
				
				if(0==$result) {
					# Extrahuji MD5 po?et
					$fileName =~ /^.*_(.*).zip$/;
					my $md5sum=$1;
					
					# Vypo?ítávám po?et MD5 souboru
					$result=`md5sum $fileName`;
					$result =~ /^(\w*)\s+.*$/;
					my $fileMd5sum=$1;
					
					if($md5sum ne $fileMd5sum) {
						print "Kontrolní ?íslo staženého souboru '$fileName' nesouhlasí!\n";
						$error=1;
					}
					else {
						push(@downloadedFiles, $fileName);
						push(@filesToRemove, $fileName);
						$retry=0;
					}
				}
				else {
					print "Při stahování došlo k chybě.\n";
					$error=1;
				}
				
				if(0==$update && 1==$error) {
					my $answer;
					print $DOWNLOAD_RETRY;
					chomp($answer = <STDIN>);
					$answer=lc($answer);
					
					$retry=0;
					foreach(@ANSWER_YES_LIST) {
						if($answer eq $_) {
							$retry=1;
							$error=0;
							last;
						}
					}
				}
				elsif(1==$update && 1==$error) {
					# Není k dispozici žádný ovládací panel a prosto není možné převzít Vaše zadání.
					# Z tohoto důvodu bude proces ukon?en.
					$retry=0;
				}
			}
			
			if(1==$error) {
				print "Soubor'$fileName' nemohl být stažen.\n";
				unlink $fileName;
				exit 1;
			}
		}
	}
}



######################################################################################################################
# Přezkoušení a rozbalení souborů
######################################################################################################################
sub unpackFiles {
	if(0!=(scalar @downloadedFiles)) {
		print $UNPACK_MSG;
		
		# Uložit instala?ní adresář
		eval { mkpath($installDir."/".$LOG_FILE_DIR) };
		
		if($@) {
			print "Instala?ní adresář nemohl být uložen.";
			exit 1;
		}
		
		# Rozbalení souborů
		foreach (@downloadedFiles) {
			$fileName	= $_;
			
			# Zde je možné smazat instalovanou předchozí verzi.
			# ?ísla md5 všech stažení souhlasí, všechny složky by tedy mělo být možné rozbalit.
			roleback($fileName);
			
			my $result=0;
			my @unzipReturn;
			@unzipReturn=`unzip -o -d '$installDir' $fileName 2>&1`;
			
			foreach(@unzipReturn) {
				if(/^\s*error:/) {
					$result=1;
				}
				elsif(/cannot find/) {
					$result=1;
				}
			}
	
			if(open(OUT, ">", $installDir."/".$LOG_FILE_DIR."/".$fileName.".log")) {
				print OUT  @unzipReturn;
				close(OUT);
			}
			
			if(0!=$result) {
				print "Není možné soubor '$fileName' rozbalit!\n";
				exit 1;
			}
		}
	}
}



######################################################################################################################
#Vytvořit ikony na ploše
######################################################################################################################
sub createDesktopIcons {
	
	if($>==0) {
		#Root User
		my $homeDir="/home/";
		if(opendir(HOME_DIR, $homeDir)) {
			my @allFiles=readdir(HOME_DIR);
			# Vyhodit na za?átku všechny záznamy.
			@allFiles=grep(!/^\./, @allFiles);
			
			foreach(@allFiles) {
				# Test, zda se jedná o jeden adresář
				if(opendir(SUB_DIR, $homeDir.$_)) {
					closedir(SUB_DIR);
					 
					createDesktopIcon($homeDir.$_, $_);
				}
			}
			closedir(HOME_DIR);
		}
	}
	else {
		# Normální uživatel
		createDesktopIcon($ENV{"HOME"}, $ENV{"USER"});
	}
}



######################################################################################################################
# Vytvořit ikony na ploše
###########################################################################################################
sub createDesktopIcon {
	my ($dir, $user) = @_;
	$dir.="/Desktop/";
	
	if(my ($login, $pass, $uid, $gid) = getpwnam($user)) {
		if(opendir(DIR, $dir)) {
			closedir(DIR);
			if(!open(ICON, ">", $dir.$DESKTOP_ICON_NAME)) {
				print "Není možné iconfile otevřít.\n";
				exit 1;
			}
			else {
				printf ICON $DESKTOP_ICON_FORMAT, $installDir, $installDir;
				close(ICON);
			}
			
			chown $uid, $gid, $dir.$DESKTOP_ICON_NAME;
			chmod 0755, $dir.$DESKTOP_ICON_NAME;
		}
	}
}



######################################################################################################################
# Úklid + Zakon?ovací práce
######################################################################################################################
sub cleanup {
	# Odstranit instala?ní složky
	if($keepPackages==0) {
		unlink(@filesToRemove);
	}
	
	# Vytvořit Symlinks pro Libs
	if(opendir(INSTALL_DIR, $installDir)) {
		chdir($installDir);
		my @allFiles=readdir(INSTALL_DIR);
		
		# Odstranit na za?átku všechny záznamy 
		@allFiles=grep(!/^\./, @allFiles);
		my @libFiles=grep(/\w+\.so\.\w*/, @allFiles);
		
		foreach(@libFiles) {
			my $fileName=$_;
			$fileName =~ /(.+\.so)\.(.*)/;
			my $baseFileName=$1;
			my $version=$2;
			
			my @v = split(/\./, $version);
			
			unlink($baseFileName);
			symlink($fileName, $baseFileName);
			foreach(@v) {
				$baseFileName.=".".$_;
				if($baseFileName ne $fileName) {
					unlink($baseFileName);
					symlink($fileName, $baseFileName);
				}
			}
		}
		
		# Změnit souborová práva 
		my @binarys;
		push(@binarys, $APPLICATION_NAME);
		push(@binarys, $PROGRAM_NAME_FOTOSHOW);
		push(@binarys, "assistant");
		chmod 0755, @binarys;
		
		closedir(INSTALL_DIR);
	}
	
	if($AFFILIATE_ID ne '') {
		if(open(SERVICESXML, ">", $installDir.$SERVICES_XML_PATH)) {
			printf SERVICESXML $SERVICES_XML_FORMAT, $AFFILIATE_ID;
			close(SERVICESXML);
		}
	}
		
	eval { mkpath($installDir."/hps") };
	
	if($>==0) {
		# Root user povolit písemný přístup k "hps" složce.
		if(!$@) {
			chmod 0777, $installDir."/hps";
		}
	}
}



######################################################################################################################
# MAIN
######################################################################################################################
# Vynutit vyprázdnění vyrovnávací paměti po každé print()-operaci.
$| = 1;

system("clear");

getOptions();

print $WELCOME;

checkProgramms();

showEula();

getInstallDir();

getIndexFile();

checkIndexFile();

downloadFiles();

unpackFiles();

cleanup();

createDesktopIcons();

printf $FINISHED_MSG_FORMAT, $installDir;

